vocabulary dos
dos definitions
hex

: #8    8  device#  !  ;
: #9    9  device#  !  ;

( Return the LFN associated with a given device & secondary address )
: findlfn   ( da sa  --  lfn )
    0  rot  rot
    98  c@  0  ?do   ( loop over all open files )
	over  263  i  +  c@  =  if   ( if device matches )
	    dup  26d  i  +  c@  1f  and  =  if   ( and secondary )
		rot  drop  259  i  +  c@  rot  rot  leave
	    then  then  loop
    2drop  ;

( Return the LFN of the command channel for a device, opening a new file if )
( necessary )
: cmd-lfn   ( da  --  lfn )
    dup  0f  findlfn  ?dup  if
	nip
    else   ( not yet open )
	0  0  $setnam  0f  swap  dup  next-lfn  >r
	r@  $setlfs  r>  $open  if
	    drop  0  then
    then  ;

( Read one directory entry into PAD, first byte contains the length of the )
( variable part )
: read-dir-rec   (  --  )
    0  pad  c!  pad  1+  4  $read  0=  swap  4  =  and  if
	pad  4  +  begin
	    1+  dup  1  $read  swap  drop  dup  0=  if
		pad  c@  1+  pad  c!  over  c@  0=  or  then
	until  drop
    then  ;

( Read from LFN and print each directory entry )
: print-dir   ( lfh  --  )
    $chkin  ?ioerr  pad  2  $read  2drop   ( skip start addr )
    begin
	read-dir-rec  pad  c@  dup  if
	    cr  pad  3  +  @  .  pad  5  +  swap  type
	    ?terminal  not  then  0=
    until  cr  $rstin  ;

( Print the directory of the default drive of the default device )
: $   (  --  )
    pad  2  over  c!  1+  [char] $  over  c!
    1+  drive#  @  [char] 0  +  swap  c!
    pad  count  0  open-file  ?ioerr  dup
    print-dir  close-file  ;

( Execute a DOS command on the default device, return the result )
: dos-cmd   ( addr count  --  addr count )
    device#  @  cmd-lfn  >r  ?dup  if
	r@  write-line  drop  else
	drop  then
    pad  20  r>  read-line  drop  pad  count  ;

( Print the error status of the default device )
: @.
    0  0  dos-cmd  type  ;

( Execute a DOS command and print the error status )
: @"
    22  word  dos-cmd  type  ;

forth definitions
decimal
